import * as React from "react";
import { InputState } from "./Input";
export interface FormInputState {
    [prop: string]: InputState;
}
export declare class FormState {
    readonly input: FormInputState;
    readonly isSubmitted: boolean;
    readonly isValid: boolean;
    readonly isDirty: boolean;
    constructor(input?: FormInputState, isSubmitted?: boolean, isValid?: boolean, isDirty?: boolean);
    toJSON(): any;
}
export interface FormProps {
    autoComplete?: string;
    onChange?: (formState: FormState) => void;
    onSubmit?: (formState: FormState) => void;
}
export interface FormComponentState {
    submitted: boolean;
}
export declare class Form extends React.Component<FormProps, FormComponentState> {
    private _formState;
    private _inputSubs;
    private _el;
    readonly form: FormState;
    constructor(props: FormProps);
    render(): JSX.Element;
    componentWillUnmount(): void;
    private _handleFormMount(el);
    refresh(): void;
    private _handleChange();
    private _handleSubmit(event);
}
