import * as React from "react";
import { Observable } from "rxjs/Rx";
export interface InputElement extends HTMLInputElement {
    inputController: Input;
    formController: any;
}
export interface Validity {
    value: string;
    isValid: boolean;
}
export interface InputChangeEvent extends Validity {
}
export interface InputProps {
    name?: string;
    value?: string;
    type?: string;
    required?: boolean;
    disabled?: boolean;
    placeholder?: string;
    updateHost?: boolean;
    maxlength?: number;
    autoComplete?: string;
    onChange?: (event?: InputChangeEvent) => void;
    onFocus?: (event?: any) => void;
    onBlur?: (event?: any) => void;
    validate?: (value?: string) => boolean;
    forcePropUpdates?: boolean;
    silentPropUpdates?: boolean;
    className?: string;
    select?: boolean;
    children?: any;
}
export interface InputState extends Validity {
    isDirty: boolean;
    isPristine: boolean;
    wasValid: boolean;
    required: boolean;
    previous?: InputState;
}
export declare class Input extends React.Component<InputProps, InputState> {
    private _value;
    protected _ref: HTMLElement;
    private _lastPropUpdate;
    private _focused;
    readonly status: Observable<InputState>;
    constructor(props: InputProps);
    static isInput: boolean;
    static defaultProps: InputProps;
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentWillReceiveProps(newProps: InputProps): void;
    protected handleChange(event: any): void;
    update(value: string, silent?: boolean, force?: boolean): void;
    readonly stateClassName: string;
    render(): JSX.Element;
    updateHostClassName(): void;
}
